import com.cycling74.max.*;
import com.cycling74.jitter.*;
import java.util.*;
import java.util.ArrayList;


public class geomThin extends MaxObject {

    private static final int[] zeroOffset = new int[] {0};

/*	geomThin() {
        declareIO(1,3);
	}*/

		public void jit_matrix(String s){
       
        JitterMatrix jm = new JitterMatrix(s);
        int planecount = jm.getPlanecount();
        int dim[] = jm.getDim();
     	int vertices =  dim[0];
		jm.frommatrix(s);
		float row[] = new float[dim[0]*planecount];
		jm.copyVectorToArray(0, zeroOffset, row, dim[0]*planecount, 0);
	    ArrayList<Float> noDupl = new ArrayList<Float>(); // arrayList size 0
        
       for ( int i=0; i < vertices; i++ ) {

          int pointA_index = i*3;
          float pointAx = row[pointA_index];
          float pointAy = row[pointA_index+1];
          float pointAz = row[pointA_index+2];
       
          for ( int j=i+1; j < vertices; j++ ) {  
              int pointB_index = j*3;
              float pointBx = row[pointB_index];
              float pointBy = row[pointB_index+1];
              float pointBz = row[pointB_index+2];
              float diffx = pointAx-pointBx;
              float diffy = pointAy-pointBy;
              float diffz = pointAz-pointBz;
              if (diffx + diffy + diffz == 0){
                 row[pointA_index] = 666;
                 row[pointA_index+1] = 666;
                 row[pointA_index+2] = 666;
              }
          }
        
       }
		  
       for (int i = 0; i < vertices*3; i++) {
            if (row[i] != 666) {
                noDupl.add (row[i]);
            }
       }

       int size = noDupl.size();
       float[] noDuplArray = new float[size];
       for (int i = 0; i < size; i++) {
           noDuplArray[i] = noDupl.get(i);
       }
       int matSize = size/3;
       JitterMatrix out = new JitterMatrix(3, "float32", matSize);
       out.copyArrayToVector(0, zeroOffset, noDuplArray, size , 0);
       outlet(0, "jit_matrix", out.getName());
       noDupl.clear();
     
     }
}































